#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include "botvisits.h"

struct botlist *bot_visits = NULL;

void
botlist_clearall ()
{
  struct botlist *b, *nb;

  b = bot_visits;
  while (b != NULL)
    {
      nb = b->next;
      free (b);
      b = nb;
    }

  bot_visits = NULL;
}

struct botlist *
newbotlist (char *name)
{
  int i;
  struct botlist *b;

  b = (struct botlist *) malloc (sizeof (struct botlist));
  if (b == NULL)
    return NULL;

  strcpy (b->name, name);

  for (i = 0; i < 31; i++)
     b->daycounts[i] = 0;
  b->next = NULL;

  return b;
}

void
botlist_updateday (char *name, int day)
{
  struct botlist *b, *newb;


  day--;

  if (day >= 31)
    return;

  if (bot_visits == NULL || (strcmp (bot_visits->name, name) > 0))
    {
      b = newbotlist (name);
      b->daycounts[day]++;
      b->next = bot_visits;
      bot_visits = b;
      return;
    }

  b = bot_visits;

  while (b != NULL)
    {
      if (!strcmp (b->name, name))
	{
	  b->daycounts[day]++;
	  return;
	}

      if (b->next == NULL ||
	  (b->next != NULL && (strcmp (b->next->name, name) > 0)))
	{
	  newb = newbotlist (name);
	  newb->daycounts[day]++;
	  newb->next = b->next;
	  b->next = newb;
	  return ;

	}
      b = b->next;
    }

}
